require "dl/import"
require "dl/struct"
require 'tcc'

module SDL
  extend DL::Importable

  dlload "libSDL.so"

  c_include [ 'SDL/SDL.h' ]
  signature_each do |t, s, r, a|
    next if s !~ /^SDL_(.*)/
    as = $1
    case t
    when :ident
      begin
        import(s, r, a)
        s[0,1] = s[0,1].downcase
        as[0,1] = as[0,1].downcase
        if r =~ /^(?:struct )?SDL_(\w+)\s*\*$/
          e = ["def #{as}(*a)",
               "p = #{s}(*a)",
               "p.null? ? p : SDL::#{$1}.new(p)",
               "end",
              ].join("\n")
          module_eval e
        else
          alias_method as, s
        end
        module_function as
      rescue
      end
    when :struct
      while a.last =~ /<anonymous>/
        a.pop
      end
      a.map! do |x|
        x.sub!(/enum <anonymous>/, 'int')
        x.sub!(/struct /, '')
        x.sub!(/unsigned /, '')
        x.sub!(/const /, '')
        x.sub!(/volatile /, '')
        x
      end
      a.each_index do |i|
        if a[i] =~ /SDL_Rect (.*)/
          a[i,1] = ["int #{$1}_x","int #{$1}_y","int #{$1}_w","int #{$1}_h"]
        end
      end
      begin
        as[0,1] = as[0,1].upcase
        const_set(as, struct(a))
      rescue
      end
    when :macro
      if a
        if r =~ /^SDL_(.[a-z].*)/
          ar = $1
          as[0,1] = as[0,1].downcase
          ar[0,1] = ar[0,1].downcase
          ar.gsub!(/SDL_/, 'sDL_')
          args = a.join(',')
          e = ["def #{as}(#{args})",
               "#{ar}",
               "end",
              ].join("\n")
          module_eval e
          module_function as
        end
      else
        if r =~ /^[\d"]/
          r = eval(r)
          const_set(as.upcase, r)
        end
      end
    end
  end

  def blitSurface(*a)
    upperBlit(*a)
  end
  module_function :blitSurface

end

SDL.init(SDL::INIT_VIDEO)
s = SDL.setVideoMode(640, 480, 16, SDL::SWSURFACE)
print "#{s.w}x#{s.h}@#{SDL::PixelFormat.new(s.format).BitsPerPixel}bpp\n"
tmp = SDL.loadBMP('icon.bmp')
b = SDL.displayFormat(tmp)
SDL.freeSurface(tmp)
SDL.setColorKey(b, SDL::SRCCOLORKEY|SDL::RLEACCEL,
                SDL.mapRGB(b.format, 255,255,255))
dr = SDL::Rect.malloc
for i in 0...50
  dr.x = 100+i*8
  dr.y = 100+i*5
  SDL.blitSurface(b, nil, s, dr)
end
SDL.flip(s)
SDL.delay(1000)
SDL.freeSurface(b)
SDL.quit()
